package org.example;

import com.fasterxml.jackson.databind.JsonNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import redis.clients.jedis.HostAndPort;
import redis.clients.jedis.JedisPooled;

import java.io.IOException;

@Component
public class LoadGameTask implements Runnable
{
    @Autowired
    private RedisServiceImpl redisService;

    @Override
    public void run()
    {
        JsonNode json;

        try (JedisPooled jedis = new JedisPooled(new HostAndPort(SteamConstants.REDIS_HOST, 6380), redisService.prepareRedisConfig()))
        {
            for (int i = 0; i < 150000; i++)
            {
                try
                {
                    json = redisService.loadGameJson(String.format(SteamConstants.GAME_DETAILS_API_TEMPLATE, i, "KZ"));
                }
                catch (IOException e)
                {
                    //TODO: add pushing logs to kibana or etc..
                    e.printStackTrace();
                    continue;
                }
                //TODO: add filter for successful and unsuccessful requests
                jedis.set(String.valueOf(i), json.toString());
                System.out.println("Current id = " + i);
                System.out.println(json.toPrettyString());
            }
        }
        catch (Exception ex)
        {
            //TODO: add pushing logs to kibana or etc..
            ex.printStackTrace();
        }
    }
}
